<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { SolutionsHero as Hero } from '~/components/solutions/index.vue';
import {
  NextStepAlt,
  SideNavigationVariant,
} from '~/components/common/index.vue';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { LivePreviewMixin } from '~/mixins';

export default Vue.extend({
  name: 'Integrations',
  components: {
    Hero,
    NextStepAlt,
    SideNavigationVariant,
  },
  mixins: [LivePreviewMixin],
  async asyncData({ $integrationsService }: any) {
    try {
      const { integrations, items } =
        await $integrationsService.getContent('integrations');
      return { integrations, items };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).integrations, this.$route.path);
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: async (updatedData) =>
          (this.integrations =
            await this.$integrationsService.transformContentfulData(
              updatedData,
            )),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <div>
    <Hero :data="integrations.hero_block" />
    <SideNavigationVariant
      class="integrations-sideNav"
      :links="integrations.side_navigation_variant.links"
    >
      <SlpContainer
        v-for="(block, num) in integrations.integrations_blocks"
        :id="block.id"
        :key="block.title"
        class="background slp-mx-lg-32"
        :class="num % 2 === 0 ? '' : 'background-odd'"
      >
        <div v-if="block.sections">
          <div v-for="section in block.sections" :key="section.title">
            <SlpTypography
              variant="heading2-bold"
              tag="h2"
              class="slp-pb-32 slp-mt-64"
            >
              {{ section.title }}
            </SlpTypography>
            <SlpTypography
              v-if="section.description"
              variant="heading5-bold"
              tag="p"
              class="slp-pb-24 card__text"
            >
              {{ section.description }}:
            </SlpTypography>
            <div class="card-container">
              <a
                v-for="item in section.items"
                :key="item.name"
                :href="item.url"
                class="card card__hover"
                :class="num % 2 === 0 ? 'card--even' : 'card--odd'"
                :data_ga_name="item.name"
                data_ga_location="body"
              >
                <SlpTypography
                  variant="body1-bold"
                  tag="p"
                  class="card__text"
                  :class="item.description ? '' : 'slp-pb-8'"
                >
                  {{ item.name }}
                </SlpTypography>
                <div v-if="item.description">
                  <SlpTypography
                    variant="body2"
                    tag="p"
                    class="slp-pb-16 card__text"
                  >
                    {{ item.description }}
                  </SlpTypography>
                </div>
                <SlpTypography
                  tag="span"
                  variant="body2"
                  class="card__learn-more"
                  >{{ $t('learnMore') }}
                  <SlpIcon
                    class="card__icon"
                    name="chevron-lg-right"
                    variant="product"
                  />
                </SlpTypography>
              </a>
            </div>
            <div
              v-if="section.subtitle"
              class="slp-pt-24"
              style="max-width: 38rem"
              v-html="$md.render(section.subtitle)"
            />
          </div>
        </div>
        <div v-else>
          <SlpTypography variant="heading2-bold" tag="h2" class="slp-pb-32">
            {{ block.title }}
          </SlpTypography>
          <SlpTypography
            v-if="block.description"
            variant="heading5-bold"
            tag="p"
            class="slp-pt-32 slp-pb-24 card__text"
          >
            {{ block.description }}:
          </SlpTypography>
          <div class="card-container">
            <div v-if="block.items[0].text">
              <div
                v-for="item in block.items"
                :key="item.name"
                class="card card--margin"
                :class="num % 2 === 0 ? 'card--even' : 'card--odd'"
              >
                <SlpTypography variant="body1-bold" tag="p">
                  {{ item.name }}
                </SlpTypography>
                <div v-html="$md.render(item.text)" />
              </div>
            </div>
            <a
              v-for="item in block.items"
              v-else
              :key="item.name"
              :href="item.url"
              class="card card__hover"
              :class="num % 2 === 0 ? 'card--even' : 'card--odd'"
              :data_ga_name="item.name"
              data_ga_location="body"
            >
              <SlpTypography
                variant="body1-bold"
                tag="p"
                class="card__text"
                :class="item.description ? '' : 'slp-pb-8'"
              >
                {{ item.name }}
              </SlpTypography>
              <SlpTypography
                v-if="item.description"
                variant="body2"
                tag="p"
                class="slp-pb-16 card__text"
              >
                {{ item.description }}
              </SlpTypography>
              <SlpTypography tag="span" variant="body2" class="card__learn-more"
                >{{ $t('learnMore') }}
                <SlpIcon
                  class="card__icon"
                  name="chevron-lg-right"
                  variant="product"
                />
              </SlpTypography>
            </a>
            <div v-if="block.call_to_action">
              <SlpButton
                :href="block.call_to_action.url"
                :data_ga_name="block.call_to_action.text"
                data_ga_location="body"
              >
                {{ block.call_to_action.text }}
              </SlpButton>
            </div>
          </div>
        </div>
      </SlpContainer>
    </SideNavigationVariant>
    <NextStepAlt />
  </div>
</template>

<style lang="scss" scoped>
.integrations-sideNav {
  :deep {
    .side-navigation__wrapper {
      z-index: 2;
    }
  }
}
.card-container {
  display: grid;
  grid-template-columns: repeat(auto-fit, minmax(315px, 1fr));
  gap: $spacing-16;
}

.background {
  padding-top: $spacing-96;
  padding-bottom: $spacing-96;
}
.background-odd {
  background: $color-surface-800;
  box-shadow: 0 0 0 100vmax $color-surface-800;
  clip-path: inset(0 -100vmax);
}

.card {
  padding: $spacing-24;
  border-radius: $spacing-8;
  background: $color-surface-800;
  color: $color-text-300;
  position: relative;
  overflow: hidden;

  &__learn-more {
    position: relative;
    z-index: 2;
    display: flex;
    align-items: center;
    justify-content: flex-start;
    gap: $spacing-4;
    color: $color-text-link-100;
  }

  &__text {
    position: relative;
    z-index: 2;
  }

  &__icon {
    display: inline-block;
    transition-timing-function: $interactive-ease;
    transition-duration: 0.3s;

    &:hover {
      padding-left: $spacing-8;
    }
  }

  &__hover {
    transition: border-radius 0.3s $interactive-ease;

    &:hover {
      border-radius: $spacing-8 $spacing-8 40px $spacing-8;

      .card__icon {
        transform: translateX($spacing-4);
      }
    }

    &::before {
      content: '';
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      background: linear-gradient(
        90.62deg,
        rgba(199, 177, 254, 0.4) 0.69%,
        rgba(255, 212, 216, 0.4) 100%
      );
      opacity: 0;
      border-radius: $spacing-8;
      transition: all 0.3s $interactive-ease;
    }

    &:hover::before {
      border-radius: $spacing-8 $spacing-8 40px $spacing-8;
      opacity: 1;
    }
  }
}

.card--margin {
  margin-bottom: $spacing-24;
}

.card--odd {
  background-color: $color-surface-50;
}

.card--even {
  background-color: $color-surface-800;
}

.card--link {
  color: $color-text-300;
}
</style>
